package downtown;

import VASSAL.tools.SequenceEncoder;

public class HideAccess implements HideAccessInterface {
	// Probably this can be collected from the subclasses of HideAccessStrategy?
	
	static private String strategies[] = { "Player", "PlayersSide", "Side" };

	public static String[] getStrategies() {
		return strategies;
	}
	
 	public static boolean hasOption(int index) {
 		if (index == 2) {
 			return true;
 		}
 		return false;
	}

	public static Class getStrategyClass(String type) {
		String name = "No such class exists";
		if (type.startsWith("Player")) {
			name = "HidePlayerStrategy";
		}
		if (type.startsWith("PlayersSide")) {
			name = "HidePlayersSideStrategy";
		}
		if (type.startsWith("Side")) {
			name = "HideSideStrategy";
		}
		try {
			return Class.forName(name);
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
		return null;
	}

	private HideAccessStrategy strategy = null;

	public HideAccess() {
		super();
	}
	public HideAccess(String whatStrategy) {
		super();
		SequenceEncoder.Decoder st = new SequenceEncoder.Decoder(whatStrategy, ':');
		String strat = st.nextToken();
		if (strat.equals("Player")) {
			strategy = new HidePlayerStrategy();
		}
		if (strat.equals("PlayersSide")) {
			strategy = new HidePlayersSideStrategy();
		}
		if (strat.equals("Side")) {
			strategy = new HideSideStrategy();
		}
		String information = st.nextToken("none");
		if (!information.equals("none")) {
			strategy.setOption(information);
		}

	}
	
	public String getSecret() {
		if (strategy == null) {
			return "none";
		}
		return strategy.getSecret();
	}

	public boolean hasAccess(String secret) {
		if (strategy == null) {
			// No strategy means no access. Is this clever?
			return false;
		}
		return strategy.hasAccess(secret);
	}

	public void setHideStrategy(HideAccessStrategy strategy) {
		this.strategy = strategy;
	}

	public String myGetType() {
		if (strategy == null) {
			return "none";
		}
		return strategy.myGetType();
	}

	public boolean hasOption() {
		if (strategy == null)
			return false;
		return strategy.hasOption();
	}

}
